define(["ace/lib/oop", "ace/mode/text", "ace/mode/text_highlight_rules"], function(oop, mText, mTextHighlightRules) {
	var HighlightRules = function() {
		var keywords = "ABSTRACT|ALL|AND|ANY|Action|ActionRealisation|Alternative|Application|ApplicationMeasurement|Attribute|AttributeConstraint|BINARY|BOTH_MATCH|BPM|BYTES|BYTES_PER_SECOND|BinaryEventPattern|BoolValue|BooleanType|BooleanValueType|CORES|COUNT|CPUUpdate|CRITICAL|CamelModel|Certifiable|Clone|CloudCredentials|CloudLocation|CloudProvider|Communication|CommunicationInstance|CommunicationMeasurement|CompositeMetric|CompositeMetricContext|CompositeMetricInstance|CompositeSecurityMetric|CompositeSecurityMetricInstance|Configuration|CoreUnit|Country|DAYS|DERIVATIVE|DIV|DOLLARS|DataCenter|DeploymentModel|Dimensionless|DoublePrecisionValue|DoubleType|E|EDate|EQUAL|EUROS|EVENT_CREATION|EVERY|EXACT|Entity|EnumerateValue|Enumeration|Event|EventInstance|Excludes|Exclusive|ExecutionContext|ExecutionModel|ExternalIdentifier|FATAL|FIRST_MATCH|FIXED|FIXED_DELAY|FIXED_RATE|FeatCardinality|Feature|FloatType|FloatsValue|Functional|FunctionalEvent|GIGABYTES|GREATER_EQUAL_THAN|GREATER_THAN|GeographicalRegion|GroupCardinality|HIGH|HOURS|HorizontalScaleRequirement|HorizontalScalingAction|Hosting|HostingInstance|INTERVAL|IaaS|ImageRequirement|Implies|InformationResourceFilter|Instance|IntType|IntegerValue|InternalComponent|InternalComponentInstance|InternalComponentMeasurement|KILOBYTES|LESS_EQUAL_THAN|LESS_THAN|LOCAL|LOW|Limit|List|LocationModel|LocationRequirement|MAP|MAX|MAXIMISE|MEAN|MEASURABLE|MEASUREMENTS_ONLY|MEDIAN|MEDIUM|MEGABYTES|MILLISECONDS|MIN|MINIMISE|MINUS|MINUTES|MODE|MODULO|MONTHS|Measurement|MetricApplicationBinding|MetricComponentBinding|MetricCondition|MetricFormula|MetricFormulaParameter|MetricModel|MetricVMBinding|MonetaryUnit|NOT|NOT_EQUAL|N_ARY|NegativeInf|NonFunctionalEvent|OR|OSRequirement|OptimisationRequirement|Organisation|OrganisationModel|PERCENTAGE|PERCENTILE|PLUS|POUNDS|PRECEDES|PaaS|PaaSageCredentials|Permission|PositiveInf|Product|Property|PropertyCondition|PropertyContext|ProvidedCommunication|ProvidedCommunicationInstance|ProvidedHost|ProvidedHostInstance|ProviderModel|ProviderRequirement|QualitativeHardwareRequirement|QuantitativeHardwareRequirement|READ|REDUCE|REMOTE|REPEAT|REPEAT_UNTIL|REQUESTS|REQUESTS_PER_SECOND|Range|RangeUnion|RawMetric|RawMetricContext|RawMetricInstance|RawSecurityMetric|RawSecurityMetricInstance|RequestUnit|RequiredCommunication|RequiredCommunicationInstance|RequiredHost|RequiredHostInstance|RequirementGroup|RequirementModel|Requires|Role|RoleAssignment|RuleTrigger|SCALE_DOWN|SCALE_IN|SCALE_OUT|SCALE_UP|SCC|SECONDS|SINGLE_EVENT|SLIDING|SLOAssessment|SOME|STD|SUCCESS|SaaS|ScalabilityModel|ScalabilityRule|Schedule|SecurityCapability|SecurityControl|SecurityDomain|SecurityModel|SecurityProperty|SecurityRequirement|SecuritySLO|Sensor|ServiceLevelObjective|ServiceResourceFilter|SimpleEvent|StorageUnit|StringType|StringValueType|StringsValue|TIMES|TIME_ONLY|TRANSACTIONS|TRANSACTIONS_PER_SECOND|TREE|ThroughputUnit|TimeIntervalUnit|Timer|TransactionUnit|TypeModel|UNARY|UnaryEventPattern|UnitModel|User|UserGroup|VM|VMInstance|VMMeasurement|VMRequirementSet|ValueToIncrease|VerticalScaleRequirement|VerticalScalingAction|WARNING|WEEKS|WHEN|WITHIN|WITHIN_MAX|WRITE|Window|XOR|action|actionRealisations|actions|add|alternativeNames|application|applications|assessment|assessmentTime|assignmentTime|attributeConstraints|attributes|bindings|cardFrom|cardTo|cardinalityMax|cardinalityMin|clones|cloudCredentials|cloudLocations|cloudProvider|codeName|communicationInstances|communications|comparisonOperator|component|componentInstance|composingMetricContexts|composingMetricInstances|compositeInternalComponents|compositeSecurityMetricInstances|compositeSecurityMetrics|conditions|configuration|configurations|configureCommand|constraints|contexts|coreUpdate|costUnit|count|countries|customServiceLevel|dataCenter|dataCentres|dataTypes|deploymentModel|deploymentModels|description|destinationVMInstance|destroyedOn|divide|domain|downloadCommand|e|email|end|endTime|entity|event|eventInstance|eventInstances|events|everyInformationResource|everyService|executionContext|executionContexts|executionModels|externalIdentifiers|false|feature|featureCardinality|firstName|formula|from|fromValue|function|functionArity|functionPattern|functionalType|geographicalRegion|globalVMRequirementSet|groupCardinality|hostingInstances|hostings|id|identifier|imageId|importURI|included|informationResourcePath|installCommand|instantiatedOn|internalComponent|internalComponentInstance|internalComponentInstances|internalComponents|interval|ioUpdate|ip|is64os|isAssignable|isMandatory|isPush|isRelative|isVariable|isViolation|lastName|layer|leftEvent|location|locationModels|locationRequirement|locations|lowLevelActions|lowerLimit|lowerOccurrenceBound|maxBenchmark|maxCPU|maxCores|maxInstances|maxOccurrenceNum|maxQuantity|maxRAM|maxStorage|measurement|measurementSize|measurementTime|measurements|memoryUpdate|metric|metricCondition|metricContext|metricInstance|metricInstances|metricModels|metrics|minBenchmark|minCPU|minCores|minInstances|minQuantity|minRAM|minStorage|multiply|networkUpdate|objectBinding|occurrenceNum|operator|optimisationFunction|order|organisation|organisationModels|os|osOrImageRequirement|owner|paasageCredentials|parameters|parent|parentRegions|password|patterns|permissions|portNumber|postalAddress|primitiveType|priority|privateSSHKey|properties|property|propertyContext|providedCommunication|providedCommunicationInstance|providedCommunicationInstances|providedCommunications|providedHost|providedHostConfiguration|providedHostInstance|providedHostInstances|providedHosts|providedPortConfiguration|provider|providerModel|providerModels|providerRequirement|providers|public|publicSSHKey|qualitativeHardwareRequirement|quantifier|quantitativeHardwareRequirement|ranges|rawData|rawSecurityMetricInstances|rawSecurityMetrics|regions|remove|repetitions|requiredCommunication|requiredCommunicationInstance|requiredCommunicationInstances|requiredCommunications|requiredHost|requiredHostConfiguration|requiredHostInstance|requiredPortConfiguration|requirementGroup|requirementModels|requirementOperator|requirements|resourceFilter|resourceFilters|resourcePattern|rightEvent|role|roleAssigments|roles|rootFeature|ruleTriggers|rules|scalabilityModels|scalabilityRule|scaleRequirements|schedule|schedules|scopeFrom|scopeTo|securityCapabilities|securityCapability|securityControls|securityDomains|securityGroup|securityLevel|securityModels|securityProperties|securityRequirements|securitySLOs|select|sensor|sensors|serviceURL|sizeType|slo|sloAssessessments|sourceVMInstance|specification|start|startCommand|startTime|status|stopCommand|storageUpdate|subClones|subDomain|subFeatures|subLocations|subProperties|threshold|timeSize|timeUnit|timeValue|timer|timers|to|toValue|totalCost|trigerringTime|true|type|typeModels|unit|unitModels|unitType|units|uploadCommand|upperLimit|upperOccurrenceBound|user|userGroup|userGroups|username|users|validity|value|valueDirection|valueType|values|variants|version|vm|vmInstance|vmInstances|vmRequirementSet|vmRequirementSets|vmType|vmTypeValue|vms|window|windowType|windows|www";
		this.$rules = {
			"start": [
				{token: "comment", regex: "\\/\\/.*$"},
				{token: "comment", regex: "\\/\\*", next : "comment"},
				{token: "string", regex: '["](?:(?:\\\\.)|(?:[^"\\\\]))*?["]'},
				{token: "string", regex: "['](?:(?:\\\\.)|(?:[^'\\\\]))*?[']"},
				{token: "constant.numeric", regex: "[+-]?\\d+(?:(?:\\.\\d*)?(?:[eE][+-]?\\d+)?)?\\b"},
				{token: "lparen", regex: "[({]"},
				{token: "rparen", regex: "[)}]"},
				{token: "keyword", regex: "\\b(?:" + keywords + ")\\b"}
			],
			"comment": [
				{token: "comment", regex: ".*?\\*\\/", next : "start"},
				{token: "comment", regex: ".+"}
			]
		};
	};
	oop.inherits(HighlightRules, mTextHighlightRules.TextHighlightRules);
	
	var Mode = function() {
		this.HighlightRules = HighlightRules;
	};
	oop.inherits(Mode, mText.Mode);
	Mode.prototype.$id = "xtext/camel";
	Mode.prototype.getCompletions = function(state, session, pos, prefix) {
		return [];
	}
	
	return {
		Mode: Mode
	};
});
